;NSIS Modern User Interface version 2.03b
;Massiv Client install script
;Written by Martin Havlista, 2003

!define MUI_PRODUCT "Massiv Client" ;Define your own software name here
!define MUI_VERSION "1.01" ;Define your own software version here
!define MUI_MASSIV_SIMULATION "Massiv Simulation"

!include "MUI.nsh"
  
!define TEMP $R0

!include "msvc.nsi"

;--------------------------------
;Configuration

  ;General
  OutFile "client_install.exe"

  ;Folder selection page
  InstallDir "$PROGRAMFILES\${MUI_PRODUCT}"
  
  ;Remember install folder
;  InstallDirRegKey HKCU "Software\massiv\${MUI_PRODUCT}" ""

;--------------------------------
;Modern UI Configuration

  !define MUI_CUSTOMPAGECOMMANDS

  !define MUI_WELCOMEPAGE
;  !define MUI_LICENSEPAGE
  !define MUI_COMPONENTSPAGE
  !define MUI_DIRECTORYPAGE
  !define MUI_STARTMENUPAGE
    !define MUI_STARTMENUPAGE_REGISTRY_ROOT "HKLM"
    !define MUI_STARTMENUPAGE_REGISTRY_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${MUI_PRODUCT}"
    !define MUI_STARTMENUPAGE_REGISTRY_VALUENAME "Start Menu Folder"
    !define MUI_STARTMENUPAGE_VARIABLE $R9

  !define MUI_FINISHPAGE
    !define MUI_FINISHPAGE_RUN "$INSTDIR\demo_client.exe"
  
  !define MUI_ABORTWARNING
  
  !define MUI_UNINSTALLER
  !define MUI_UNCONFIRMPAGE

;--------------------------------
;Pages

  !insertmacro MUI_PAGECOMMAND_WELCOME
;  !insertmacro MUI_PAGECOMMAND_LICENSE
  Page custom SetInstallPage
  !insertmacro MUI_PAGECOMMAND_COMPONENTS
  !insertmacro MUI_PAGECOMMAND_DIRECTORY
  !insertmacro MUI_PAGECOMMAND_STARTMENU
  !insertmacro MUI_PAGECOMMAND_INSTFILES
  !insertmacro MUI_PAGECOMMAND_FINISH
;--------------------------------
;Languages
 
  !insertmacro MUI_LANGUAGE "English"
  
;--------------------------------
;Language Strings

  ;Description
  LangString DESC_SecClient ${LANG_ENGLISH} "Install ${MUI_PRODUCT}"
  LangString DESC_SecDesktop ${LANG_ENGLISH} "Create desktop shortcut"
  LangString DESC_SecQuick ${LANG_ENGLISH} "Create quicklaunch shortcut"
;--------------------------------
;Data
  
#  LicenseData "${NSISDIR}\Contrib\Modern UI\License.txt"
  
;--------------------------------
;Reserve Files

  ;Things that need to be extracted on first (keep these lines before any File command!)
  ;Only useful for BZIP2 compression
  !insertmacro MUI_RESERVEFILE_WELCOMEFINISHPAGE

  ReserveFile "install.ini"

;--------------------------------
;Installer Sections

Section "${MUI_PRODUCT}" SecClient

  ; config files
  CreateDirectory "$INSTDIR\conf"
  SetOutPath "$INSTDIR\conf"
  File "conf\massiv.logger.conf"
  File "conf\massiv.replication.conf"
  File "conf\massiv.settings.conf"
  File "conf\massiv.paths.conf"

  ; simulation config file
  ClearErrors
    CopyFiles /SILENT "$0\massiv.server_nodes.conf" "$INSTDIR\conf\massiv.server_nodes.conf"
  IfErrors error
  Goto next
  error:
  MessageBox MB_OK "Error while copying file $0\massiv.server_nodes.conf."
  Abort
  next:
  
  ;try to copy client1/login/default if possible
  userhome::get_home_dir
  pop $R1
  StrCmp $R1 "" next2

    CreateDirectory "$R1\.massiv"
    CreateDirectory "$R1\.massiv\client"
    CreateDirectory "$R1\.massiv\client\login"

    ClearErrors
    CopyFiles /SILENT "$0\client1\login\default" "$R1\.massiv\client\login\default"

  next2:
  
  ; client files
  SetOutPath "$INSTDIR"
  File "massiv.conf"
  File "demo_client.exe"
  File "demo_client.ico"

  ;sdl files
  File "sdl\jpeg.dll"
  File "sdl\libpng1.dll"
  File "sdl\SDL.dll"
  File "sdl\SDL_image.dll"
  File "sdl\zlib.dll"

  ; dll files
  Call copy_msvc_dll_files

  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${MUI_PRODUCT}" "DisplayName" "${MUI_PRODUCT}"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${MUI_PRODUCT}" "UninstallString" '"$INSTDIR\Uninstall.exe"'
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${MUI_PRODUCT}" "DisplayIcon" "$INSTDIR\demo_client.ico"

  SetOutPath "$INSTDIR"
  WriteUninstaller "$INSTDIR\Uninstall.exe"

  !insertmacro MUI_STARTMENU_WRITE_BEGIN
  ; FIXME - dat na vyber, jestli instalovat pro jednoho uzivatele nebo pro vsechny uzivatele
  SetShellVarContext all
  CreateDirectory "$SMPROGRAMS\${MUI_STARTMENUPAGE_VARIABLE}"
  ;IfFileExists "$SMPROGRAMS\${MUI_STARTMENUPAGE_VARIABLE}" createIcons
    ;SetShellVarContext current
    ;CreateDirectory "$SMPROGRAMS\${MUI_STARTMENUPAGE_VARIABLE}"

  ;createIcons:
    CreateShortcut "$SMPROGRAMS\${MUI_STARTMENUPAGE_VARIABLE}\Demo Client.lnk" "$INSTDIR\demo_client.exe" "" "$INSTDIR\demo_client.ico"
    CreateShortCut "$SMPROGRAMS\${MUI_STARTMENUPAGE_VARIABLE}\Uninstall.lnk" "$INSTDIR\Uninstall.exe"
  !insertmacro MUI_STARTMENU_WRITE_END

SectionEnd

Section "Desktop icon" SecDesktop
  SetShellVarContext all
  CreateShortcut "$DESKTOP\Demo Client.lnk" "$INSTDIR\demo_client.exe" "" "$INSTDIR\demo_client.ico"
SectionEnd

Section "Quick Launch icon" SecQuick
  SetShellVarContext all
  StrCmp $QUICKLAUNCH $TEMP next
    CreateShortcut "$QUICKLAUNCH\Demo Client.lnk" "$INSTDIR\demo_client.exe" "" "$INSTDIR\demo_client.ico"
  next:
SectionEnd

;--------------------------------
;Descriptions

!insertmacro MUI_FUNCTIONS_DESCRIPTION_BEGIN
  !insertmacro MUI_DESCRIPTION_TEXT ${SecClient} $(DESC_SecClient)
  !insertmacro MUI_DESCRIPTION_TEXT ${SecDesktop} $(DESC_SecDesktop)
  !insertmacro MUI_DESCRIPTION_TEXT ${SecQuick} $(DESC_SecQuick)
!insertmacro MUI_FUNCTIONS_DESCRIPTION_END

;--------------------------------
;Uninstaller Section

Section "Uninstall"

  ;delete files
  Delete "$INSTDIR\conf\massiv.paths.conf"
  Delete "$INSTDIR\conf\massiv.logger.conf"
  Delete "$INSTDIR\conf\massiv.replication.conf"
  Delete "$INSTDIR\conf\massiv.server_nodes.conf"
  Delete "$INSTDIR\conf\massiv.settings.conf"
  RMDir "$INSTDIR\conf"

  Delete "$INSTDIR\massiv.conf"
  Delete "$INSTDIR\demo_client.exe"
  Delete "$INSTDIR\demo_client.ico"
  Delete "$INSTDIR\Uninstall.exe"

  ;directories
  RMDIr /r "$INSTDIR\data"
  RMDIr /r "$INSTDIR\conf"
  RMDIr "$INSTDIR\login"  ; if it is empty

  ;sdl files
  Delete "$INSTDIR\jpeg.dll"
  Delete "$INSTDIR\libpng1.dll"
  Delete "$INSTDIR\SDL.dll"
  Delete "$INSTDIR\SDL_image.dll"
  Delete "$INSTDIR\zlib.dll"

  ;dll files
  Call un.delete_msvc_dll_files

  ; FIXME - dat na vyber jestli smazat vse anebo ponechat vygenerovane veci
  RMDir "$INSTDIR\login"
  RMDir "$INSTDIR"

  ; delete startmenu
  SetShellVarContext all

  ReadRegStr $R0 "${MUI_STARTMENUPAGE_REGISTRY_ROOT}" "${MUI_STARTMENUPAGE_REGISTRY_KEY}" "${MUI_STARTMENUPAGE_REGISTRY_VALUENAME}"
  StrCmp $R0 "" noshortcuts
    Delete "$SMPROGRAMS\$R0\Demo Client.lnk"
    Delete "$SMPROGRAMS\$R0\Uninstall.lnk"
    RMDir "$SMPROGRAMS\$R0"
  noshortcuts:

  ; delete registry
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${MUI_PRODUCT}"

  Delete "$DESKTOP\Demo Client.lnk"
  Delete "$QUICKLAUNCH\Demo Client.lnk"

  !insertmacro MUI_UNFINISHHEADER

SectionEnd

;--------------------------------
;Callback functions

Function .onInit
  ; test if user have right to install/uninstall programs on this machine
  ClearErrors
  UserInfo::GetName
  IfErrors Win9x
  Pop $R0
  ClearErrors
  UserInfo::GetAccountType
  IfErrors Win9x
  Pop $R1
  StrCmp $R1 "" done "" ; win98 (tested)
  StrCmp $R1 "Admin" done ""
  StrCmp $R1 "Power" done ""
    MessageBox MB_OK "You dont have rights to install software on this machine."
    abort
  Win9x: ; no problemo with admin on win9x
  done:

  ReadRegStr $R0 HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${MUI_PRODUCT}" "DisplayName"
  StrCmp $R0 "" noerror
    MessageBox MB_OK "${MUI_PRODUCT} already installed. Uninstall it first."
    Abort
  noerror:

  ;Extract InstallOptions INI Files
  !insertmacro MUI_INSTALLOPTIONS_EXTRACT "install.ini"

FunctionEnd

Function un.onInit
  call un.test_registry
FunctionEnd

;--------------------------------
;User functions

Function un.test_registry
  ;Read registry values
  ReadRegStr $R0 HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${MUI_PRODUCT}" "DisplayName"
  StrCmp $R0 "" "" noerror
    MessageBox MB_OK "Error during uninstallation. Registry values are corrupted."
    Abort
  noerror:
FunctionEnd

;--------------------------------
;Install page function

Function SetInstallPage
  ;!insertmacro MUI_INSTALLOPTIONS_WRITE "install.ini" "Field 2" "State" "$INSTDIR\generated"
  !insertmacro MUI_HEADER_TEXT "Select directory" "Select directory with simulation config file massiv.server_nodes.conf"
  ; read generated directory
  ReadRegStr $0 HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${MUI_MASSIV_SIMULATION}" "GeneratedDirectory"
  !insertmacro MUI_INSTALLOPTIONS_WRITE "install.ini" "Field 2" "State" "$0"

  again:
  !insertmacro MUI_INSTALLOPTIONS_DISPLAY_RETURN "install.ini"
  pop ${TEMP}
  StrCmp ${TEMP} "back" "" next
    ; go back
    return
  next:
  StrCmp ${TEMP} "success" "" next2
    ;check if generated config files exist
    !insertmacro MUI_INSTALLOPTIONS_READ $0 "install.ini" "Field 2" "State"
    ClearErrors
    FileOpen $R0 "$0\massiv.server_nodes.conf" "r"
    IfErrors error
    FileClose $R0
    Goto done
  error:
    MessageBox MB_OK "Error: selected directory doesn't contain file massiv.server_nodes.conf"
    goto again
  done:
  next2:
FunctionEnd

